Index: /trunk/source/Lib/TLibEncoder/TEncGOP.cpp
===================================================================
--- /trunk/source/Lib/TLibEncoder/TEncGOP.cpp	(revision 1412)
+++ /trunk/source/Lib/TLibEncoder/TEncGOP.cpp	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -108,8 +108,5 @@
   m_associatedIRAPType = NAL_UNIT_CODED_SLICE_IDR_N_LP;
   m_associatedIRAPPOC  = 0;
-#if W0038_DB_OPT
   m_pcDeblockingTempPicYuv = NULL;
-#endif
-  return;
 }
 
@@ -128,5 +125,4 @@
 Void  TEncGOP::destroy()
 {
-#if W0038_DB_OPT
   if (m_pcDeblockingTempPicYuv)
   {
@@ -135,5 +131,4 @@
     m_pcDeblockingTempPicYuv = NULL;
   }
-#endif
 }
 
@@ -161,10 +156,10 @@
   m_layerId              = pcTEncTop->getLayerId();
   m_viewId               = pcTEncTop->getViewId();
+#endif
+
 #if NH_3D
   m_viewIndex            = pcTEncTop->getViewIndex();
   m_isDepth              = pcTEncTop->getIsDepth();
-#endif
-#endif
-#if NH_3D_IC
+
   m_aICEnableCandidate   = pcTEncTop->getICEnableCandidate();
   m_aICEnableNum         = pcTEncTop->getICEnableNum();
@@ -212,18 +207,32 @@
 
 
-Int TEncGOP::xWriteParameterSets (AccessUnit &accessUnit, TComSlice *slice)
+#if NH_MV
+Int TEncGOP::xWriteParameterSets (AccessUnit &accessUnit, TComSlice *slice, const Bool bSeqFirst, const Bool bWriteVps )
+#else
+Int TEncGOP::xWriteParameterSets (AccessUnit &accessUnit, TComSlice *slice, const Bool bSeqFirst)
+#endif
 {
   Int actualTotalBits = 0;
 
 #if NH_MV
-  if ( getLayerId() == 0 )
+  if ( bWriteVps )
   {
     actualTotalBits += xWriteVPS(accessUnit, m_pcEncTop->getVPS());
   }
 #else
-  actualTotalBits += xWriteVPS(accessUnit, m_pcEncTop->getVPS());
-#endif
-  actualTotalBits += xWriteSPS(accessUnit, slice->getSPS());
-  actualTotalBits += xWritePPS(accessUnit, slice->getPPS());
+  if (bSeqFirst)
+  {
+    actualTotalBits += xWriteVPS(accessUnit, m_pcEncTop->getVPS());
+  }
+#endif
+  if (m_pcEncTop->SPSNeedsWriting(slice->getSPS()->getSPSId())) // Note this assumes that all changes to the SPS are made at the TEncTop level prior to picture creation (TEncTop::xGetNewPicBuffer).
+  {
+    assert(bSeqFirst); // Implementations that use more than 1 SPS need to be aware of activation issues.
+    actualTotalBits += xWriteSPS(accessUnit, slice->getSPS());
+  }
+  if (m_pcEncTop->PPSNeedsWriting(slice->getPPS()->getPPSId())) // Note this assumes that all changes to the PPS are made at the TEncTop level prior to picture creation (TEncTop::xGetNewPicBuffer).
+  {
+    actualTotalBits += xWritePPS(accessUnit, slice->getPPS());
+  }
 
   return actualTotalBits;
@@ -513,5 +522,4 @@
     seiMessages.push_back(seiChromaResamplingFilterHint);
   }
-#if U0033_ALTERNATIVE_TRANSFER_CHARACTERISTICS_SEI
   if(m_pcCfg->getSEIAlternativeTransferCharacteristicsSEIEnable())
   {
@@ -520,5 +528,4 @@
     seiMessages.push_back(seiAlternativeTransferCharacteristics);
   }
-#endif
 }
 
@@ -555,5 +562,5 @@
     {
       // Gradual decoding refresh SEI
-      SEIGradualDecodingRefreshInfo *gradualDecodingRefreshInfoSEI = new SEIGradualDecodingRefreshInfo();
+      SEIRegionRefreshInfo *gradualDecodingRefreshInfoSEI = new SEIRegionRefreshInfo();
       gradualDecodingRefreshInfoSEI->m_gdrForegroundFlag = true; // Indicating all "foreground"
       seiMessages.push_back(gradualDecodingRefreshInfoSEI);
@@ -1046,4 +1053,13 @@
 
 
+#if X0038_LAMBDA_FROM_QP_CAPABILITY
+static UInt calculateCollocatedFromL0Flag(const TComSlice *pSlice)
+{
+  const Int refIdx = 0; // Zero always assumed
+  const TComPic *refPicL0 = pSlice->getRefPic(REF_PIC_LIST_0, refIdx);
+  const TComPic *refPicL1 = pSlice->getRefPic(REF_PIC_LIST_1, refIdx);
+  return refPicL0->getSlice(0)->getSliceQp() > refPicL1->getSlice(0)->getSliceQp();
+}
+#else
 static UInt calculateCollocatedFromL1Flag(TEncCfg *pCfg, const Int GOPid, const Int gopSize)
 {
@@ -1094,4 +1110,5 @@
   }
 }
+#endif
 
 
@@ -1141,9 +1158,14 @@
 Void TEncGOP::compressPicInGOP( Int iPOCLast, Int iNumPicRcvd, TComList<TComPic*>& rcListPic,
                                 TComList<TComPicYuv*>& rcListPicYuvRecOut,  std::list<AccessUnit>& accessUnitsInGOP,
-                                Bool isField, Bool isTff, const InputColourSpaceConversion snr_conversion, const Bool printFrameMSE, Int iGOPid )
+                                Bool isField, Bool isTff, const InputColourSpaceConversion snr_conversion, const Bool printFrameMSE, const Bool printMSSSIM, Int iGOPid )
 #else
 Void TEncGOP::compressGOP( Int iPOCLast, Int iNumPicRcvd, TComList<TComPic*>& rcListPic,
                            TComList<TComPicYuv*>& rcListPicYuvRecOut, std::list<AccessUnit>& accessUnitsInGOP,
+#if JVET_F0064_MSSSIM            
+                           Bool isField, Bool isTff, const InputColourSpaceConversion snr_conversion, const Bool printFrameMSE, const Bool printMSSSIM )
+#else
+
                            Bool isField, Bool isTff, const InputColourSpaceConversion snr_conversion, const Bool printFrameMSE )
+#endif
 #endif
 {
@@ -1193,5 +1215,7 @@
     clock_t iBeforeTime = clock();
 
+#if !X0038_LAMBDA_FROM_QP_CAPABILITY
     UInt uiColDir = calculateCollocatedFromL1Flag(m_pcCfg, iGOPid, m_iGopSize);
+#endif
 
     /////////////////////////////////////////////////////////////////////////////////////////////////// Initial to start encoding
@@ -1237,4 +1261,8 @@
     xGetBuffer( rcListPic, rcListPicYuvRecOut, iNumPicRcvd, iTimeOffset, pcPic, pcPicYuvRecOut, pocCurr, isField );
 
+#if REDUCED_ENCODER_MEMORY
+    pcPic->prepareForReconstruction();
+
+#endif
     //  Slice data initialization
     pcPic->clearSliceBuffer();
@@ -1247,7 +1275,4 @@
     m_pcSliceEncoder->initEncSlice ( pcPic, iPOCLast, pocCurr, iGOPid, pcSlice, isField );
 #endif
-
-    //Set Frame/Field coding
-    pcSlice->getPic()->setField(isField);
 
     pcSlice->setLastIDR(m_iLastIDR);
@@ -1441,10 +1466,7 @@
     Int numDirectRefLayers = vps    ->getNumDirectRefLayers( getLayerId() );
 #endif
-#if NH_3D_QTL
+
+#if NH_3D
     pcSlice->setIvPicLists( m_ivPicLists );
-#endif
-#if NH_3D
-
-
     Int gopNum = (pcSlice->getRapPicFlag() && getLayerId() > 0) ? MAX_GOP : iGOPid;
     GOPEntry gopEntry      = m_pcCfg->getGOPEntry( gopNum );
@@ -1517,8 +1539,6 @@
       pcSlice->checkInCompPredRefLayers();
     }
-#if NH_3D_IV_MERGE
     // This needs to be done after initialization of 3D tool parameters.
     pcSlice->setMaxNumMergeCand      ( m_pcCfg->getMaxNumMergeCand()   + ( ( pcSlice->getMpiFlag( ) || pcSlice->getIvMvPredFlag( ) || pcSlice->getViewSynthesisPredFlag( )   ) ? 1 : 0 ));
-#endif
 #endif
 
@@ -1545,12 +1565,8 @@
     pcSlice->setRefPicList ( rcListPic );
 #endif
-#if NH_3D_NBDV
+#if NH_3D
     pcSlice->setDefaultRefView();
-#endif
-#if NH_3D_ARP
     //GT: This seems to be broken when layerId in vps is not equal to layerId in nuh
     pcSlice->setARPStepNum(m_ivPicLists);
-#endif
-#if NH_3D_IC
     pcSlice->setICEnableCandidate( m_aICEnableCandidate );
     pcSlice->setICEnableNum( m_aICEnableNum );
@@ -1576,5 +1592,10 @@
     if (pcSlice->getSliceType() == B_SLICE)
     {
+#if X0038_LAMBDA_FROM_QP_CAPABILITY
+      const UInt uiColFromL0 = calculateCollocatedFromL0Flag(pcSlice);
+      pcSlice->setColFromL0Flag(uiColFromL0);
+#else
       pcSlice->setColFromL0Flag(1-uiColDir);
+#endif
       Bool bLowDelay = true;
       Int  iCurrPOC  = pcSlice->getPOC();
@@ -1603,5 +1624,7 @@
     }
 
+#if !X0038_LAMBDA_FROM_QP_CAPABILITY
     uiColDir = 1-uiColDir;
+#endif
 
     //-------------------------------------------------------------
@@ -1609,5 +1632,5 @@
 
     pcSlice->setList1IdxToList0Idx();
-#if NH_3D_TMVP
+#if NH_3D
     if(pcSlice->getLayerId())
       pcSlice->generateAlterRefforTMVP();
@@ -1659,10 +1682,4 @@
 
     // SAIT_VSO_EST_A0033
-#if H_3D_FCO
-    Bool flagRec;
-    flagRec =  ((m_pcEncTop->getIvPicLists()->getPicYuv( pcSlice->getViewIndex(), false, pcSlice->getPOC(), true) == NULL) ? false: true);
-    pcRdCost->setVideoRecPicYuv( m_pcEncTop->getIvPicLists()->getPicYuv( pcSlice->getViewIndex(), false, pcSlice->getPOC(), flagRec ) );
-    pcRdCost->setDepthPicYuv   ( m_pcEncTop->getIvPicLists()->getPicYuv( pcSlice->getViewIndex(), true, pcSlice->getPOC(), false ) );
-#else    
     Int curAuxId     = pcSlice->getVPS()->getAuxId( getLayerId() ); 
     Int curDepthFlag = pcSlice->getIsDepth(); 
@@ -1670,5 +1687,5 @@
     pcRdCost->setVideoRecPicYuv( m_pcEncTop->getIvPicLists()->getPicYuv( pcSlice->getViewIndex(), false       , 0       , pcSlice->getPOC(), true ) );
     pcRdCost->setDepthPicYuv   ( m_pcEncTop->getIvPicLists()->getPicYuv( pcSlice->getViewIndex(), curDepthFlag, curAuxId, pcSlice->getPOC(), false ) );
-#endif
+
     // LGE_WVSO_A0119
     Bool bUseWVSO  = m_pcEncTop->getUseWVSO();
@@ -1708,5 +1725,4 @@
       pcSlice->setMvdL1ZeroFlag(false);
     }
-    pcPic->getSlice(pcSlice->getSliceIdx())->setMvdL1ZeroFlag(pcSlice->getMvdL1ZeroFlag());
 
 
@@ -1733,5 +1749,4 @@
 #endif
 
-#if U0132_TARGET_BITS_SATURATION
       if (m_pcRateCtrl->getCpbSaturationEnabled() && frameLevel != 0)
       {
@@ -1746,19 +1761,10 @@
         estimatedCpbFullness -= m_pcRateCtrl->getBufferingRate();
         // prevent underflow
-#if V0078_ADAPTIVE_LOWER_BOUND
         if (estimatedCpbFullness - estimatedBits < m_pcRateCtrl->getRCPic()->getLowerBound())
         {
           estimatedBits = max(200, estimatedCpbFullness - m_pcRateCtrl->getRCPic()->getLowerBound());
         }
-#else
-        if (estimatedCpbFullness - estimatedBits < (Int)(m_pcRateCtrl->getCpbSize()*0.1f))
-        {
-          estimatedBits = max(200, estimatedCpbFullness - (Int)(m_pcRateCtrl->getCpbSize()*0.1f));
-        }
-#endif
-
         m_pcRateCtrl->getRCPic()->setTargetBits(estimatedBits);
       }
-#endif
 
       Int sliceQP = m_pcCfg->getInitialQP();
@@ -1782,5 +1788,4 @@
           bits = m_pcRateCtrl->getRCPic()->getRefineBitsForIntra( bits );
 
-#if U0132_TARGET_BITS_SATURATION
           if (m_pcRateCtrl->getCpbSaturationEnabled() )
           {
@@ -1795,17 +1800,9 @@
             estimatedCpbFullness -= m_pcRateCtrl->getBufferingRate();
             // prevent underflow
-#if V0078_ADAPTIVE_LOWER_BOUND
             if (estimatedCpbFullness - bits < m_pcRateCtrl->getRCPic()->getLowerBound())
             {
               bits = estimatedCpbFullness - m_pcRateCtrl->getRCPic()->getLowerBound();
             }
-#else
-            if (estimatedCpbFullness - bits < (Int)(m_pcRateCtrl->getCpbSize()*0.1f))
-            {
-              bits = estimatedCpbFullness - (Int)(m_pcRateCtrl->getCpbSize()*0.1f);
-            }
-#endif
           }
-#endif
 
           if ( bits < 200 )
@@ -1849,5 +1846,5 @@
     UInt uiNumSliceSegments = 1;
 
-#if NH_3D_NBDV
+#if NH_3D
       if(pcSlice->getViewIndex() && !pcSlice->getIsDepth()) //Notes from QC: this condition shall be changed once the configuration is completed, e.g. in pcSlice->getSPS()->getMultiviewMvPredMode() || ARP in prev. HTM. Remove this comment once it is done.
       {
@@ -1855,11 +1852,6 @@
         pcPic->setNumDdvCandPics(pcPic->getDisCandRefPictures(iColPoc));
       }
-#endif
-#if NH_3D
       pcSlice->setDepthToDisparityLUTs();
 
-#endif
-
-#if NH_3D_NBDV
       if(pcSlice->getViewIndex() && !pcSlice->getIsDepth() && !pcSlice->isIntra()) //Notes from QC: this condition shall be changed once the configuration is completed, e.g. in pcSlice->getSPS()->getMultiviewMvPredMode() || ARP in prev. HTM. Remove this comment once it is done.
       {
@@ -1935,5 +1927,4 @@
     if ( m_pcCfg->getDeblockingFilterMetric() )
     {
-#if W0038_DB_OPT
       if ( m_pcCfg->getDeblockingFilterMetric()==2 )
       {
@@ -1942,9 +1933,6 @@
       else
       {
-#endif
       applyDeblockingFilterMetric(pcPic, uiNumSliceSegments);
-#if W0038_DB_OPT
-      }
-#endif
+      }
     }
     m_pcLoopFilter->loopFilterPic( pcPic );
@@ -1953,17 +1941,43 @@
     // Set entropy coder
     m_pcEntropyCoder->setEntropyCoder   ( m_pcCavlcCoder );
+
+    // write various parameter sets
+#if JCTVC_Y0038_PARAMS
+    //bool writePS = m_bSeqFirst || (m_pcCfg->getReWriteParamSetsFlag() && (pcPic->getSlice(0)->getSliceType() == I_SLICE));
+#if NH_MV
+    bool writePS = m_bSeqFirst || (m_pcCfg->getReWriteParamSetsFlag() && (pcSlice->isIRAP())  );
+#else
+    bool writePS = m_bSeqFirst || (m_pcCfg->getReWriteParamSetsFlag() && (pcSlice->isIRAP()));
+#endif 
+    if (writePS)
+    {
+#if NH_MV
+      if ( m_layerId == pcSlice->getSPS()->getLayerId() )
+      {
+        m_pcEncTop->setParamSetChanged(pcSlice->getSPS()->getSPSId(), false );
+      }
+      
+      if ( m_layerId == pcSlice->getPPS()->getLayerId() )
+      {
+        m_pcEncTop->setParamSetChanged(pcSlice->getPPS()->getSPSId(), true  );        
+      }
+
+#else
+      m_pcEncTop->setParamSetChanged(pcSlice->getSPS()->getSPSId(), pcSlice->getPPS()->getPPSId());
+#endif
+    }
+#if NH_MV
+    actualTotalBits += xWriteParameterSets(accessUnit, pcSlice, writePS, (getLayerId() == 0) && m_bSeqFirst );
+#else
+    actualTotalBits += xWriteParameterSets(accessUnit, pcSlice, writePS);
+#endif
+
+    if (writePS)
+#else
+    actualTotalBits += xWriteParameterSets(accessUnit, pcSlice, m_bSeqFirst);
+
     if ( m_bSeqFirst )
-    {
-      // write various parameter sets
-      actualTotalBits += xWriteParameterSets(accessUnit, pcSlice);
-#if H_3D_PPS_FIX_DEPTH
-      if(!pcSlice->getIsDepth() || !pcSlice->getViewIndex() )
-      {
-#endif
-#if H_3D_PPS_FIX_DEPTH
-      }
-#endif
-
-
+#endif
+    {
       // create prefix SEI messages at the beginning of the sequence
       assert(leadingSeiMessages.empty());
@@ -1998,5 +2012,4 @@
       m_pcEncTop->getRDGoOnSbacCoder()->setBitstream(&tempBitCounter);
       m_pcSAO->initRDOCabacCoder(m_pcEncTop->getRDGoOnSbacCoder(), pcSlice);
-#if OPTIONAL_RESET_SAO_ENCODING_AFTER_IRAP
       m_pcSAO->SAOProcess(pcPic, sliceEnabled, pcPic->getSlice(0)->getLambdas(),
                           m_pcCfg->getTestSAODisableAtPictureLevel(),
@@ -2005,7 +2018,4 @@
                           m_pcCfg->getSaoCtuBoundary(),
                           m_pcCfg->getSaoResetEncoderStateAfterIRAP());
-#else
-      m_pcSAO->SAOProcess(pcPic, sliceEnabled, pcPic->getSlice(0)->getLambdas(), m_pcCfg->getTestSAODisableAtPictureLevel(), m_pcCfg->getSaoEncodingRate(), m_pcCfg->getSaoEncodingRateChroma(), m_pcCfg->getSaoCtuBoundary());
-#endif
       m_pcSAO->PCMLFDisableProcess(pcPic);
       m_pcEncTop->getRDGoOnSbacCoder()->setBitstream(NULL);
@@ -2158,9 +2168,23 @@
       trailingSeiMessages.push_back(decodedPictureHashSei);
     }
+
+    m_pcCfg->setEncodedFlag(iGOPid, true);
+
+    Double PSNR_Y;
+#if JVET_F0064_MSSSIM
+    xCalculateAddPSNRs( isField, isTff, iGOPid, pcPic, accessUnit, rcListPic, dEncTime, snr_conversion, printFrameMSE, printMSSSIM, &PSNR_Y );
+#else
+    xCalculateAddPSNRs( isField, isTff, iGOPid, pcPic, accessUnit, rcListPic, dEncTime, snr_conversion, printFrameMSE, &PSNR_Y );
+#endif
+    
+    // Only produce the Green Metadata SEI message with the last picture.
+    if( m_pcCfg->getSEIGreenMetadataInfoSEIEnable() && pcSlice->getPOC() == ( m_pcCfg->getFramesToBeEncoded() - 1 )  )
+    {
+      SEIGreenMetadataInfo *seiGreenMetadataInfo = new SEIGreenMetadataInfo;
+      m_seiEncoder.initSEIGreenMetadataInfo(seiGreenMetadataInfo, (UInt)(PSNR_Y * 100 + 0.5));
+      trailingSeiMessages.push_back(seiGreenMetadataInfo);
+    }
+    
     xWriteTrailingSEIMessages(trailingSeiMessages, accessUnit, pcSlice->getTLayer(), pcSlice->getSPS());
-
-    m_pcCfg->setEncodedFlag(iGOPid, true);
-
-    xCalculateAddPSNRs( isField, isTff, iGOPid, pcPic, accessUnit, rcListPic, dEncTime, snr_conversion, printFrameMSE );
 
     printHash(m_pcCfg->getDecodedPictureHashSEIType(), digestStr);
@@ -2187,5 +2211,4 @@
         m_pcRateCtrl->getRCGOP()->updateAfterPicture( estimatedBits );
       }
-#if U0132_TARGET_BITS_SATURATION
       if (m_pcRateCtrl->getCpbSaturationEnabled())
       {
@@ -2193,5 +2216,4 @@
         printf(" [CPB %6d bits]", m_pcRateCtrl->getCpbState());
       }
-#endif
     }
 
@@ -2223,4 +2245,13 @@
     iGOPid=effFieldIRAPMap.restoreGOPid(iGOPid);
     }
+#if REDUCED_ENCODER_MEMORY
+
+    pcPic->releaseReconstructionIntermediateData();
+    if (!isField) // don't release the source data for field-coding because the fields are dealt with in pairs. // TODO: release source data for interlace simulations.
+    {
+      pcPic->releaseEncoderSourceImageData();
+    }
+
+#endif
   } // iGOPid-loop
 
@@ -2232,5 +2263,9 @@
 }
 
+#if JVET_F0064_MSSSIM
+Void TEncGOP::printOutSummary(UInt uiNumAllPicCoded, Bool isField, const Bool printMSEBasedSNR, const Bool printSequenceMSE, const Bool printMSSSIM, const BitDepths &bitDepths)
+#else
 Void TEncGOP::printOutSummary(UInt uiNumAllPicCoded, Bool isField, const Bool printMSEBasedSNR, const Bool printSequenceMSE, const BitDepths &bitDepths)
+#endif
 {
   assert (uiNumAllPicCoded == m_gcAnalyzeAll.getNumPic());
@@ -2245,4 +2280,6 @@
   const ChromaFormat chFmt = m_pcCfg->getChromaFormatIdc();
 
+
+#if JVET_F0064_MSSSIM
   //-- all
 #if NH_MV
@@ -2251,4 +2288,22 @@
   printf( "\n\nSUMMARY --------------------------------------------------------\n" );
 #endif
+  m_gcAnalyzeAll.printOut('a', chFmt, printMSEBasedSNR, printSequenceMSE, printMSSSIM, bitDepths);
+
+  printf( "\n\nI Slices--------------------------------------------------------\n" );
+  m_gcAnalyzeI.printOut('i', chFmt, printMSEBasedSNR, printSequenceMSE, printMSSSIM, bitDepths);
+
+  printf( "\n\nP Slices--------------------------------------------------------\n" );
+  m_gcAnalyzeP.printOut('p', chFmt, printMSEBasedSNR, printSequenceMSE, printMSSSIM, bitDepths);
+
+  printf( "\n\nB Slices--------------------------------------------------------\n" );
+  m_gcAnalyzeB.printOut('b', chFmt, printMSEBasedSNR, printSequenceMSE, printMSSSIM, bitDepths);
+#else
+  //-- all
+#if NH_MV
+  printf( "\n\nSUMMARY -------------------------------------------- LayerId %2d\n", getLayerId() );
+#else
+  printf( "\n\nSUMMARY --------------------------------------------------------\n" );
+#endif
+
   m_gcAnalyzeAll.printOut('a', chFmt, printMSEBasedSNR, printSequenceMSE, bitDepths);
 
@@ -2261,5 +2316,5 @@
   printf( "\n\nB Slices--------------------------------------------------------\n" );
   m_gcAnalyzeB.printOut('b', chFmt, printMSEBasedSNR, printSequenceMSE, bitDepths);
-
+#endif
   if (!m_pcCfg->getSummaryOutFilename().empty())
   {
@@ -2277,14 +2332,14 @@
   {
     //-- interlaced summary
-#if TEMPORAL_SUBSAMPLE
     m_gcAnalyzeAll_in.setFrmRate( m_pcCfg->getFrameRate() / (Double)m_pcCfg->getTemporalSubsampleRatio());
-#else
-    m_gcAnalyzeAll_in.setFrmRate( m_pcCfg->getFrameRate());
-#endif
     m_gcAnalyzeAll_in.setBits(m_gcAnalyzeAll.getBits());
     // prior to the above statement, the interlace analyser does not contain the correct total number of bits.
 
     printf( "\n\nSUMMARY INTERLACED ---------------------------------------------\n" );
+#if JVET_F0064_MSSSIM
+    m_gcAnalyzeAll_in.printOut('a', chFmt, printMSEBasedSNR, printSequenceMSE, printMSSSIM, bitDepths);
+#else
     m_gcAnalyzeAll_in.printOut('a', chFmt, printMSEBasedSNR, printSequenceMSE, bitDepths);
+#endif
 
     if (!m_pcCfg->getSummaryOutFilename().empty())
@@ -2374,7 +2429,5 @@
   }
 
-#if !NH_MV
   assert (rpcPic != NULL);
-#endif
   assert (rpcPic->getPOC() == pocCurr);
 
@@ -2420,7 +2473,13 @@
 }
 
-Void TEncGOP::xCalculateAddPSNRs( const Bool isField, const Bool isFieldTopFieldFirst, const Int iGOPid, TComPic* pcPic, const AccessUnit&accessUnit, TComList<TComPic*> &rcListPic, const Double dEncTime, const InputColourSpaceConversion snr_conversion, const Bool printFrameMSE )
-{
-  xCalculateAddPSNR( pcPic, pcPic->getPicYuvRec(), accessUnit, dEncTime, snr_conversion, printFrameMSE );
+#if JVET_F0064_MSSSIM
+Void TEncGOP::xCalculateAddPSNRs( const Bool isField, const Bool isFieldTopFieldFirst, const Int iGOPid, TComPic* pcPic, const AccessUnit&accessUnit, TComList<TComPic*> &rcListPic, const Double dEncTime, const InputColourSpaceConversion snr_conversion, const Bool printFrameMSE, const Bool printMSSSIM, Double* PSNR_Y )
+{
+  xCalculateAddPSNR( pcPic, pcPic->getPicYuvRec(), accessUnit, dEncTime, snr_conversion, printFrameMSE, printMSSSIM, PSNR_Y );
+#else
+Void TEncGOP::xCalculateAddPSNRs( const Bool isField, const Bool isFieldTopFieldFirst, const Int iGOPid, TComPic* pcPic, const AccessUnit&accessUnit, TComList<TComPic*> &rcListPic, const Double dEncTime, const InputColourSpaceConversion snr_conversion, const Bool printFrameMSE, Double* PSNR_Y )
+{
+  xCalculateAddPSNR( pcPic, pcPic->getPicYuvRec(), accessUnit, dEncTime, snr_conversion, printFrameMSE, PSNR_Y );
+#endif
 
   //In case of field coding, compute the interlaced PSNR for both fields
@@ -2477,15 +2536,27 @@
       if( (pcPic->isTopField() && isFieldTopFieldFirst) || (!pcPic->isTopField() && !isFieldTopFieldFirst))
       {
-        xCalculateInterlacedAddPSNR(pcPic, correspondingFieldPic, pcPic->getPicYuvRec(), correspondingFieldPic->getPicYuvRec(), snr_conversion, printFrameMSE );
+#if JVET_F0064_MSSSIM
+        xCalculateInterlacedAddPSNR(pcPic, correspondingFieldPic, pcPic->getPicYuvRec(), correspondingFieldPic->getPicYuvRec(), snr_conversion, printFrameMSE, printMSSSIM, PSNR_Y );
+#else
+        xCalculateInterlacedAddPSNR(pcPic, correspondingFieldPic, pcPic->getPicYuvRec(), correspondingFieldPic->getPicYuvRec(), snr_conversion, printFrameMSE, PSNR_Y );
+#endif
       }
       else
       {
-        xCalculateInterlacedAddPSNR(correspondingFieldPic, pcPic, correspondingFieldPic->getPicYuvRec(), pcPic->getPicYuvRec(), snr_conversion, printFrameMSE );
-      }
-    }
-  }
-}
-
-Void TEncGOP::xCalculateAddPSNR( TComPic* pcPic, TComPicYuv* pcPicD, const AccessUnit& accessUnit, Double dEncTime, const InputColourSpaceConversion conversion, const Bool printFrameMSE )
+#if JVET_F0064_MSSSIM
+        xCalculateInterlacedAddPSNR(correspondingFieldPic, pcPic, correspondingFieldPic->getPicYuvRec(), pcPic->getPicYuvRec(), snr_conversion, printFrameMSE, printMSSSIM, PSNR_Y );
+#else
+        xCalculateInterlacedAddPSNR(correspondingFieldPic, pcPic, correspondingFieldPic->getPicYuvRec(), pcPic->getPicYuvRec(), snr_conversion, printFrameMSE, PSNR_Y );
+#endif
+      }
+    }
+  }
+}
+
+#if JVET_F0064_MSSSIM
+Void TEncGOP::xCalculateAddPSNR( TComPic* pcPic, TComPicYuv* pcPicD, const AccessUnit& accessUnit, Double dEncTime, const InputColourSpaceConversion conversion, const Bool printFrameMSE, const Bool printMSSSIM, Double* PSNR_Y )
+#else
+Void TEncGOP::xCalculateAddPSNR( TComPic* pcPic, TComPicYuv* pcPicD, const AccessUnit& accessUnit, Double dEncTime, const InputColourSpaceConversion conversion, const Bool printFrameMSE, Double* PSNR_Y )
+#endif
 {
   Double  dPSNR[MAX_NUM_COMPONENT];
@@ -2556,4 +2627,31 @@
   }
 
+#if EXTENSION_360_VIDEO
+  m_ext360.calculatePSNRs(pcPic);
+#endif
+
+#if JVET_F0064_MSSSIM
+  //===== calculate MS-SSIM =====
+  Double  MSSSIM[MAX_NUM_COMPONENT] = {0,0,0};
+  if (printMSSSIM) 
+  {
+    for(Int chan=0; chan<pcPicD->getNumberValidComponents(); chan++)
+    {
+      const ComponentID ch  = ComponentID(chan);
+      const TComPicYuv *pOrgPicYuv =(conversion!=IPCOLOURSPACE_UNCHANGED) ? pcPic ->getPicYuvTrueOrg() : pcPic ->getPicYuvOrg();
+      const Pel*  pOrg      = pOrgPicYuv->getAddr(ch);
+      const Int   orgStride = pOrgPicYuv->getStride(ch);
+      const Pel*  pRec      = picd.getAddr(ch);
+      const Int   recStride = picd.getStride(ch);
+      const Int   width     = pcPicD->getWidth (ch) - (m_pcEncTop->getPad(0) >> pcPic->getComponentScaleX(ch));
+      const Int   height    = pcPicD->getHeight(ch) - ((m_pcEncTop->getPad(1) >> (pcPic->isField()?1:0)) >> pcPic->getComponentScaleY(ch));
+      const UInt  bitDepth  = pcPic->getPicSym()->getSPS().getBitDepth(toChannelType(ch));
+ 
+      MSSSIM[ch] = xCalculateMSSSIM (pOrg, orgStride, pRec, recStride, width, height, bitDepth);
+    }
+  }
+#endif
+
+
 #if NH_3D_VSO
 #if H_3D_VSO_SYNTH_DIST_OUT
@@ -2562,5 +2660,4 @@
 #endif
   /* calculate the size of the access unit, excluding:
-   *  - any AnnexB contributions (start_code_prefix, zero_byte, etc.,)
    *  - SEI NAL units
    */
@@ -2576,4 +2673,13 @@
     {
       numRBSPBytes += numRBSPBytes_nal;
+      // add start code bytes (Annex B)
+      if (it == accessUnit.begin() || (*it)->m_nalUnitType == NAL_UNIT_VPS || (*it)->m_nalUnitType == NAL_UNIT_SPS || (*it)->m_nalUnitType == NAL_UNIT_PPS)
+      {
+        numRBSPBytes += 4;
+      }
+      else
+      {
+        numRBSPBytes += 3;
+      }
     }
   }
@@ -2583,18 +2689,49 @@
 
   //===== add PSNR =====
+#if JVET_F0064_MSSSIM
+  m_gcAnalyzeAll.addResult (dPSNR, (Double)uibits, MSEyuvframe, MSSSIM);
+#else
   m_gcAnalyzeAll.addResult (dPSNR, (Double)uibits, MSEyuvframe);
+#endif
+#if EXTENSION_360_VIDEO
+  m_ext360.addResult(m_gcAnalyzeAll);
+#endif
 
   TComSlice*  pcSlice = pcPic->getSlice(0);
   if (pcSlice->isIntra())
   {
+#if JVET_F0064_MSSSIM
+    m_gcAnalyzeI.addResult (dPSNR, (Double)uibits, MSEyuvframe, MSSSIM);
+#else
     m_gcAnalyzeI.addResult (dPSNR, (Double)uibits, MSEyuvframe);
+#endif
+#if EXTENSION_360_VIDEO
+    m_ext360.addResult(m_gcAnalyzeI);
+#endif
+    *PSNR_Y = dPSNR[COMPONENT_Y];
   }
   if (pcSlice->isInterP())
   {
+#if JVET_F0064_MSSSIM
+    m_gcAnalyzeP.addResult (dPSNR, (Double)uibits, MSEyuvframe, MSSSIM);
+#else
     m_gcAnalyzeP.addResult (dPSNR, (Double)uibits, MSEyuvframe);
+#endif
+#if EXTENSION_360_VIDEO
+    m_ext360.addResult(m_gcAnalyzeP);
+#endif
+    *PSNR_Y = dPSNR[COMPONENT_Y];
   }
   if (pcSlice->isInterB())
   {
+#if JVET_F0064_MSSSIM
+    m_gcAnalyzeB.addResult (dPSNR, (Double)uibits, MSEyuvframe, MSSSIM);
+#else
     m_gcAnalyzeB.addResult (dPSNR, (Double)uibits, MSEyuvframe);
+#endif
+#if EXTENSION_360_VIDEO
+    m_ext360.addResult(m_gcAnalyzeB);
+#endif
+    *PSNR_Y = dPSNR[COMPONENT_Y];
   }
 
@@ -2647,8 +2784,17 @@
   printf(" [Y %6.4lf dB    U %6.4lf dB    V %6.4lf dB]", dPSNR[COMPONENT_Y], dPSNR[COMPONENT_Cb], dPSNR[COMPONENT_Cr] );
 #endif
+#if JVET_F0064_MSSSIM
+  if (printMSSSIM)
+  {
+    printf(" [MS-SSIM Y %1.6lf    U %1.6lf    V %1.6lf]", MSSSIM[COMPONENT_Y], MSSSIM[COMPONENT_Cb], MSSSIM[COMPONENT_Cr] );
+  }  
+#endif
   if (printFrameMSE)
   {
     printf(" [Y MSE %6.4lf  U MSE %6.4lf  V MSE %6.4lf]", MSEyuvframe[COMPONENT_Y], MSEyuvframe[COMPONENT_Cb], MSEyuvframe[COMPONENT_Cr] );
   }
+#if EXTENSION_360_VIDEO
+  m_ext360.printPerPOCInfo();
+#endif
   printf(" [ET %5.0f ]", dEncTime );
 
